// ==============================================================
// ORBITER MODULE: MonAddon
// Exemple simple pour dmarrer un nouvel addon et mieux comprendre
// comment faire un projet.
// Copyright (C) 2004-2013 Dansteph
// Vous te libre de modifier tout ceci comme vous le voulez.
// un p'tit merci dans votre doc si ca vous sert peut etre ?
// ==============================================================



#include "orbitersdk.h"				// la SDK d'orbiter
#include "MesDonneeSimulation.h"	// pour que votre classe vois la structure "DATASIMULATION"
#include "OrbiterSoundSDK40.h"		// la SDK d'orbiterSound 4.0

///////////////////////////////////////////////////////////////////////////
// Quelques constantes de votre vaisseau, pousse racteur etc etc.
// pour savoir ou elle sont utilise faite clique 
// droit+trouver references
///////////////////////////////////////////////////////////////////////////
const double PB_FUELMASS	= 750.0;
const double PB_ISP			= 5e4;
const double PB_MAXMAINTH	= 3e4;
const double PB_MAXHOVERTH	= 1.5e4;
const double PB_MAXRCSTH	= 2e2;
double LiftCoeff (double aoa);

///////////////////////////////////////////////////////////////////////////
// Votre Classe "MonAddon" c'est ici que vous devrez declarer vos fonctions
// et variables, n'oubliez pas la regle absolue: vous devez initialiser
// avec une valeur par defaut dans clbkSetClassCap CHAQUE variable que vous
// declarerez ci-dessous.
///////////////////////////////////////////////////////////////////////////
class MonAddon: public VESSEL2 {
public:
	MonAddon (OBJHANDLE hVessel, int flightmodel): VESSEL2 (hVessel, flightmodel) {}

	////////////////////////////////////////////////////////////////////////////
	// Les callback d'orbiter, fonctions appelle par Orbiter  diffrent stade 
	// de la simulation, je les ai toutes liste ici. Celle commentes avec "//" 
	// devant ne sont pas utilise dans ces listing, si vous en avez besoin 
	// decommentez les et rajoutez la function dans un listing cpp (regardez 
	// comment sont faites celle qui ne sont pas commentes)
	// REGARDEZ LA DOC ET LES AUTRES EXEMPLES DE LA SDK A LEURS PROPOS
	////////////////////////////////////////////////////////////////////////////
	void clbkSetClassCaps (FILEHANDLE cfg);	// appell a l'initialisation de votre vessel, les initialisations vont ici
	void clbkPostStep (double simt, double simdt, double mjd); // appell chaque image
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *keystate); // ici va le traitement des touches clavier
	void clbkSaveState (FILEHANDLE scn); // pour sauver l'etat de votre vessel (variable, animations etc etc)
	void clbkLoadStateEx (FILEHANDLE scn, void *status); // pour recharger l'etat de votre vessel (variables animations etc etc)
	void clbkPostCreation ();	// execute une fois aprs la cration du vessel dans Orbiter, on s'en sert pour OrbiterSound 4.0
	//void clbkDockEvent (int dock, OBJHANDLE mate); // appell quand votre vessel ce dock ou s'undock
	//void clbkADCtrlMode (DWORD mode); // appell quand le mode des RCS change (linaire rotation)
	//bool clbkLoadPanel (int id);
	//bool clbkPanelMouseEvent (int id, int event, int mx, int my);
	//bool clbkPanelRedrawEvent (int id, int event, SURFHANDLE surf);
	//bool clbkLoadVC (int id);
	//bool clbkVCMouseEvent (int id, int event, VECTOR3 &p);
	//bool clbkVCRedrawEvent (int id, int event, SURFHANDLE surf);
	//void clbkSetStateEx (const void *status);
	//void clbkPostCreation ();
	//void clbkFocusChanged (bool getfocus, OBJHANDLE hNewVessel, OBJHANDLE hOldVessel);
	//void clbkPreStep (double simt, double simdt, double mjd);
	//bool clbkPlaybackEvent (double simt, double event_t, const char *event_type, const char *event);
	//void clbkVisualCreated (VISHANDLE vis, int refcount);
	//void clbkVisualDestroyed (VISHANDLE vis, int refcount);
	//void clbkDrawHUD (int mode, const HUDPAINTSPEC *hps, HDC hDC);
	//void clbkRCSMode (int mode);
	//void clbkHUDMode (int mode);
	//void clbkMFDMode (int mfd, int mode);
	//void clbkNavMode (int mode, bool active);
	//void clbkAnimate (double simt);
	//int  clbkConsumeDirectKey (char *keystate);
	//bool clbkLoadGenericCockpit ();
	// FIN DES CALLBACKS ORBITER

	////////////////////////////////////////////////////////////////////////////
	// EXEMPLE VARIABLE:
	// Mettez ci-dessous vos variables courante. Juste pour l'exemple j'ai mis quelques variables
	// utilise par cette demo.
	// Une du type double "dTempDeSimulationTotal" qui voluera avec le temps total de simulation,
	// sera affiche avec l'affichage debug d'Orbiter, sera sauve et recharge et remise  zro 
	// par une touche clavier. Elle affichera le temp total de simulation (toutes les fois
	// que vous avez vol avec le mme scenario)
	// En suivant ces variable a travers le listing (clique droit trouver reference) vous
	// pourrez voir comment marche typiquement "la vie d'une variable" dans un addon Orbiter. 
	// Chaue fois quelle apparaitra il y aura un petit commentaire pour expliquer quelque chose.
	// Comme vous n'en aurez pas besoin dans votre addon, virez les quand vous aurez vu 
	// comment ca marche.
	//
	// N'OUBLIEZ PAS D'INITIALISER AVEC UNE VALEUR PAR DEFAUT CHAQUE VARIABLE DECLAREE
	// CI-DESSOUS DANS clbkSetClassCap(on ne peut PAS initialiser une variable dans une classe)
	//
	// Bonne ide nom variable: Une bonne habitude c'est de mettre en premiere lettre minuscule 
	// le type de variable (d pour double i pour int, f pour float b pour bolean etc etc) 
	// et ensuite de mettre un nom explicite avec des mot dont la premiere lettre est une majuscule.
	// le listing sera beaucoup plus lisible. (c'est aussi une convention d'ecriture C++)
	//
	// JUSTE: fTauxOxygeneCabine dAnimationTrain bAutopilotAscention iTempRestantAvantAtterrissage
	// FAUX:  fdrtgh IRTFD MONOXYGENE i785 AUTOPilot MaVariableQueJeSaisPlusCeQuelleFaitCarLeNomEstIdiot
	////////////////////////////////////////////////////////////////////////////
	int    iTempDeSimulationTotal;	  // utilis par la demo
	int	   iDetecteChangementSeconde; // utilise pour incrmenter la variable iTempDeSimulationTotal
	BOOL   bAltitudeSoundPlayed;	  // utilis par la dmo d'OrbiterSound
	BOOL   bRadarFlagForSound;		  // utilis par la demo d'OrbiterSound

	int MyID;	// sert a OrbiterSound 4.0 c'est l'ID de votre vessel qui est a fournir 
				//  toutes les fonctions OrbiterSound. Gardez le si vous utilisez OrbiterSound
	int	iSlotChargeEtJoue;			// Utilise par la fonction utilitaire d'OrbiterSound "ChargeEtJoue"	
									// Une fonction super utile dont vous ne pourrez plus vous passer

	////////////////////////////////////////////////////////////////////////////
	// EXEMPLE FONCTION:
	// Mettez ci-dessous vos fonctions. Juste pour l'exemple j'ai mis une fonction 
	// qui sera appelle par la touche clavier "C" et remettra a zro notre variable 
	// "dTempDeSimulationTotal" et une autre juste pour le demo qui va jouer nos sons
	// OrbiterSound a chaque image.
	// Comme les variables, utilisez des noms explicite dont chaque mot commence par 
	// une majuscule. Le listing devient lisible comme un roman si vous faite cela.
	////////////////////////////////////////////////////////////////////////////
	void RemiseAZeroTempDeSimulation(void);
	void JoueMesSonsChaqueImage(void);
	void ChargeEtJoue(char* NomWav,int Volume=255,VECTOR3 *v3Pos=NULL); // fonction utilitaire son cockpit

	// Declaration de la structure "DATASIMULATION" (voir header "MesDonneeSimulation.h")
	// gardez le.
	DATASIMULATION Data;
};


////////////////////////////////////////////////////////////////////////
// DECLARATION NOM CLE DE WAV POUR ORBITERSOUND
// --------------------------------------------
// OrbiterSound a 60 "slots" pour les sons (de 1 a 60)
// comme il est plus lisible dans le code de voir "LoadSon(REACTEUR)" "JoueSon(REACTEUR)"
// que "LoadSon(47)" "JoueSon(47)" on defini ici quelques noms choisi et on leurs donne
// une valeur, au lieu d'un nombre on peut ds lors utiliser ce nom au lieu d'un chiffre. 
// on le fait dans ce header car il est visible par toutes les fonctions de votre vessel.
#define MONWAV500METRES				1
#define MONWAVRADAR					2
#define MONWAVEXTERN_OVNI			3
#define MONWAVDEBOUTLESGARS			4
#define MONSON_3D_INTERNE			5
#define SLOTVOIX1					6 // pour la fonction utilitaire "ChargeEtJoue"
#define SLOTVOIX2					7 // pour la fonction utilitaire "ChargeEtJoue"
#define SLOTVOIX3					8 // pour la fonction utilitaire "ChargeEtJoue"

