
// STRUCTURE DE VOS VARIABLES D'INFORMATION DE SIMULATION (Lire plus bas)
// CETTE STRUCTURE EST DECLAREE DANS VOTRE CLASSE AVEC
// LE NOM "Data" 
// VOUS POUVEZ RAJOUTER DES VARIABLES ICI ET LES COLLECTER DANS "clbkPostStep"
typedef struct{
	double dAltitude;			// altitude en metre
	double dVitesse;			// vitesse en m/s
	double dVitesseKmh;			// vitesse en km/h
	double dVitesseVerticale;	// vitesse verticale en m/s
	double dAtmPressure;		// pression atmosphere en pascal (101300 Pa =terre au sol)
	double dDynPressure;		// Pression dynamique
	double dAirSpeedKmh;		// Vitesse en Km/h
	double dMachNumber;			// nombre de mach
	double dAOA;				// AOA En radian (angle d'attaque) (Data.dAOA*DEG pour degr)
	double dPitch;				// pitch En radian Data.dPitch*DEG pour degr)
	double dBank;				// Bank En radian Data.dBank*DEG pour degr)
	int	   iTimeWarp;			// Acceleration du temps (1= normal sinon 10,1000,10000 etc etc)
	VECTOR3 vHorizonAirspeedVector; // vecteur vitesse (voir doc orbiter)
	char cNomPlanete[255];		// nom planete pres de laquelle vous etes (SOI) en anglais
	bool bAirRespirable;		// Si l'air est respirable a l'endroit ou est votre vaisseau (terre et <10000m)
	double dMass;				// Masse totale de votre vaisseau en kg
	double dGVert;				// acceleration "G" composante vertical seulement (tete/pied pour un pilote assis)
	double dGTotal;				// acceleration "G" composante total (tout vecteur)
}DATASIMULATION;

////////////////////////////////////////////////////////////////////////////
// LISEZ ATTENTIVEMENT C'EST HYPER PRATIQUE POUR VOTRE ADDON!!!!! 
// REGARDEZ LE DEBUT DE "clbkPostStep" pour les voirs EN ACTION ET LISEZ 
// BIEN CI DESSOUS.
//
// POURQUOI ?
// ----------
// Ca c'est un truc que j'utilise dans tout mes programmes. Il permet de rationaliser
// la collecte d'informations de simulation, d'optimiser les performances et d'avoir
// une meilleur organisations pour encore plus de lisibilit. Je vous explique:
//
// Votre vaiseau aura forcement besoin d'informations d'Orbiter comme l'altitude
// la vitesse verticale et bien d'autre. Par exemple pour avoir notre altitude
// il suffit de faire MonAltitude=GetAltitude(); (GetAltitude est une fonction 
// Orbiter)
//
// Comme vous aurez probablement besoin de votre altitude a beaucoup d'endroits
// de votre code vous allez appeler la fonction "GetAltitude()" autant de fois
// et ceci aura un cout en cycle processeur  chaque appel. Pas glop !
//
// au niveau lisibilit pas toutes les fonctions d'orbiter son aussi clair
// ni simple que GetAltitude(), certaines collecte de donnes peuvent prendre
// plusieurs ligne et avoir un code un peut compliqu, il vaut donc mieux
// le faire qu'une seul fois au dbut de chaque image et ranger la valeur obtenue
// dans une variable au nom explicite prete a tre utilise par le reste de votre
// code. Il y a d'autres avantages mais j'essaie de faire court ;)
//
// COMMENT CA MARCHE ?
// -------------------
// Je range donc toutes les variable de donnes de simulation dans une structure
// et ***au dbut*** de chaque image je collecte toutes les donnees de simulation et 
// les ranges dans cette structure. Tout le reste du code de votre vaisseau
// pourra ds lors y acceder sans appeller aucune fonction supplmentaire, les codes
// compliqu ne seront appel qu'une fois et les valeurs range dans des variables
// au nom explicite que VOUS aurez dcid. (vous pouvez modifier la structure)
//
// Au dessus je declare un "structure de donne" pour imager c'est une sorte de
// "boite" ou vous pouvez mettre des "objets" (variable) aucquel vous pourrez acceder.
//
// Dans ce listing vous n'avez que la declaration, le "plan", pour que cette "boite"
// existe reellement il faut la declarer et lui donner un nom. Comme on va le 
// faire dans votre classe "MonAddon" cette "boite" sera membre de votre classe
// et chaque vaisseau (instance) aura sa copie spcifique.
// Dans ce code j'ai declar cette structure dans la classe comme ceci:
// DATASIMULATION Data;
// 
// Je l'ai appelle "Data" mais j'aurais pu lui donner un autre nom ou en declarer
// plusieurs avec des noms diffrents.
//
// Pour acceder au "objets" de la boite il suffit de donner le nom de la "boite"
// et le nom de la variable spar par un point, exemple:
// Data.dAltitude=1000; // assigne une valeur  la variable altitude
// MonAltitude=Data.dAltitude; // retrouve la valeur de cette variable (1000 dans ce cas)
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// TRUC: Si j'ai des fonctions qui utilisent beaucoup de variables que je ne
// veut pas mlanger je les declare dans une autre structure par exemple
// pour un autopilote:
// typedef struct{
//	bool bEnFonction;
//  double dAltitudeVisee;
//  double dVitesseDesiree;
//  ... etc etc
//}AUTOPILOTASCENSION;
//
// Et dans la classe: AUTOPILOTASCENSION AutoAscent;
//
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// EN SAVOIR PLUS SUR LES STRUCTURES ?
// -----------------------------------
//
// Les structures c'est typiquement un des truc qui rend le C++ si puissant,
// c'est de la "programation oriente objet" Il permet d'avoir
// un niveau "bas" avec les dtails cach dans des objets et ensuite de 
// manipuler ces objets  un haut niveau.
//
// exemple avec une maison: elle  un nom, des pieces et chaque piece 
//  des armoires lit ou autre. Nous pouvons caracteriser cette maison dans 
// un "plan" une "structure" , ensuite en declarer autant que nous voulons, 
// les imbriquer et les manipuler comme nous voulons.
//
// LES PLANS:
// ---------
// on fait le plan d'une piece typique, elle peut avoir une armoire, 
// une table un frigo et un lit par exemple. On defini une structure:
//
// typedef struct{
//      int Armoire;
//      int Table;
//      int Lit;
//		bool Frigo;
//}PIECEMAISON;
//
// Ensuite on fait le plan de la maison typique en y declarant nos structures
// des pieces (imbrication de structure):
//
// typedef struct{
//      PIECEMAISON Cuisine;
//      PIECEMAISON Chambre;
//      PIECEMAISON Salon;
//      int AutreVariables;
//}MAISON;
//
// L'UTILISATION PRATIQUE
// ----------------------
//
// Vous allez voir la puissance du truc :))) (dingue)
// Donc nos maison n'existent pas encore, maintenant
// on les cres:
//
// MAISON MaisonBernard={0};  (le "={0}" initialise toute les variables de la strucure  zro)
// MAISON MaisonMarie={0};
//
// Et maintenant on manipule, d'abord on defini les carateristiques de chaque maison:
//
// MaisonBernard.Salon.Frigo=TRUE;  // bernard a un frigo dans son Salon (variable bool 1 ou 0)
// MaisonMarie.Cuisine.Frigo=TRUE;	// Marie elle est normale, elle  son frigo dans sa cuisine 
// MaisonMarie.Chambre.Armoire=153; // Par contre elle  153 armoire dans sa chambre :)
//
// Bernard aimerais bien aussi une collection de 153 armoire mais dans sa cuisine:
// MaisonBernard.Cuisine.Armoire=MaisonMarie.Chambre.Armoire;
//
// et puis flute, finalement ce copieur de bernard veut exactement la meme maison que marie:
// MaisonBernard=MaisonMarie;
//
// ET ENCORE CE N'EST QU'UNE **INFIME** DEMONSTRATION DE LA PUISSANCE DU C++ !!!! :))))
// (mais pourquoi je hurle comme ca moi ? :wonder: )
////////////////////////////////////////////////////////////////////////////