#include "MaClasseAddon.h"
////////////////////////////////////////////////////////////////////////////
// LiftCoeff - Seule fonction globale (OBSOLETE??)
// ---------
//
// Cete fonction est globale et sert  orbiter pour calculer la portance
// en fonction de l'angle d'attaque. L'adresse de cette fonction est fournie
// a la fonction Orbiter "SetLiftCoeffFunc". Orbiter ce chargera de l'appeler
// au bon moment pour appliquer ce modele de vol a votre vessel.
// le model de vol du ShuttlePB est vraiment basique et cette fonction est
// suppose etre obsolete maintenant, la nouvelle methode est par fonction
// "createAirfoil", (cre ailes) pour faire un vessel avec ailes reportez vous 
//  l'exemple DeltaGlider qui est  jour. Pour faire une fuse regardez avec 
// l'exemple atlantis. (booster)
////////////////////////////////////////////////////////////////////////////


// Calculate lift coefficient [Cl] as a function of aoa (angle of attack) over -Pi ... Pi
// Implemented here as a piecewise linear function
double LiftCoeff (double aoa)
{
	const int nlift = 9;
	static const double AOA[nlift] = {-180*RAD,-60*RAD,-30*RAD,-1*RAD,15*RAD,20*RAD,25*RAD,60*RAD,180*RAD};
	static const double CL[nlift]  = {       0,      0,   -0.1,     0,   0.2,  0.25,   0.2,     0,      0};
	static const double SCL[nlift] = {(CL[1]-CL[0])/(AOA[1]-AOA[0]), (CL[2]-CL[1])/(AOA[2]-AOA[1]),
		                              (CL[3]-CL[2])/(AOA[3]-AOA[2]), (CL[4]-CL[3])/(AOA[4]-AOA[3]),
									  (CL[5]-CL[4])/(AOA[5]-AOA[4]), (CL[6]-CL[5])/(AOA[6]-AOA[5]),
									  (CL[7]-CL[6])/(AOA[7]-AOA[6]), (CL[8]-CL[7])/(AOA[8]-AOA[7])};
	int i;
	for (i = 0; i < nlift-1 && AOA[i+1] < aoa; i++);
	return CL[i] + (aoa-AOA[i])*SCL[i];
}