#include "MaClasseAddon.h"

/////////////////////////////////////////////////////////////////////////////
// TRUC: Pour dsactiver le son "custom" dans votre addon enlevez ce listing de votre 
// projet et enlevez la fonction "JoueMesSonsChaqueImage" de votre classe et de clbkPostStep
// Votre vessel utilisera les sons par defaut (dommage, jettez un oeil a "ReplaceStockSound"
// ci-dessous avant de tout jeter.)
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// TRUC: La documentation d'OrbiterSound c'est le header "OrbiterSoundSDK40.h"
// une fois tout les commentaires lu ci-dessous allez y faire un tour.
/////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// clbkPostCreation - CallBack Orbiter
// ------------
//
// Fonction appelle par orbiter juste aprs que la cration du vessel soit termine
// dans Orbiter, sert  faire des initialisations supplmentaire qui auraient besoin
// que le vessel soit deja cre.
//
// Dans cet exemple On s'en sert pour les inits OrbiterSound 4.0
////////////////////////////////////////////////////////////////////////////
void MonAddon::clbkPostCreation()
{
		////////////////////////////////////////////////////////////////
		// ORBITERSOUND EXEMPLE - INIT ET LOADING DES WAV
		////////////////////////////////////////////////////////////////
		// Avec la fonction dessous on ce connecte a OrbiterSound et celui
		// ci nous donne un ID unique (MyID)  fournir pour toutes les 
		// fonctions sons de votre vessel.
		// Si la connexion choue (OrbiterSound pas install chez le client par exemple)
		// toutes les fonctions chouerons silencieusement sans crasher Orbiter.
		MyID=ConnectToOrbiterSoundDLL(GetHandle());

		////////////////////////////////////////////////////////////////
		// DEFINIT UN CHEMIN PAR DEFAUT POUR VOS SONS (optionnel) 
		////////////////////////////////////////////////////////////////
		// Nous allons utiliser une nouvelle fonction de OrbiterSound 4.0 qui vous vite
		// de marquer le chemin complet pour charger un son  chaque fois.
		// 
		// Sans cette fonction vous devriez faire ceci: (multipliez par le nombre de sons, c'est chiant)
		// RequestLoadVesselWave(MyID,1,"Sound\\_CustomVesselsSounds\\MonAddon\\myUfoSound.wav",INTERNAL_ONLY)
		//
		// Avec vous ne vous souciez que du nom du fichier wav pour toutes les fonctions de chargement:
		// RequestLoadVesselWave(MyID,1,"myUfoSound.wav",INTERNAL_ONLY)
		SetMyDefaultWaveDirectory("Sound\\_CustomVesselsSounds\\MonAddon\\");

		///////////////////////////////////////////
		//IMPORTANT - REPERTOIRE SON DE VOTRE ADDON
		//---------
		// Tout vos wav doivent aller dans un rpertoire "Sound\\_CustomVesselsSounds\\MonAddon" 
		// ou "MonAddon" est un repertoire avec un nom suffisement specifique
		// pour ne pas avoir de mix infernal avec un autre addon. 

		////////////////////////////////////////////////////////////////
		// ReplaceStockSound - REMPLACE SONS PAR DEFAUT
		// ------------------
		// maintenant on peut par exemple remplacer tout les sons par defauts
		// du vessel (reacteur, rcs, air conditionn, ambiance etc etc.. )en utilisant la 
		// fonction "ReplaceStockSound" c'est une manire rapide et facile de 
		// customiser les sons de votre addon. Les sons remplacs aurons exactement
		// le mme comportement que ceux d'origine (fade avec distance etc etc)
		// vous n'avez pas besoin de les jouer ou de vous en occuper du tout.
		// clique droit sur "REPLACE_MAIN_THRUST" pour voir tout les son que vous 
		// pouvez remplacer)
		ReplaceStockSound(MyID,"myMainThrust.wav",REPLACE_MAIN_THRUST);
		ReplaceStockSound(MyID,"myaircond.wav",	REPLACE_AIR_CONDITIONNING);

		// maintenant votre vessel a des sons custom (videmment vous n'utiliserez 
		// pas ceux de cette dmo qui sont moche et juste pour la demonstration) 
		// Vous pouvez vous arretez la ou utiliser toute les capacit d'OrbiterSound 
		// pour rajouter encore plus de sons. Je vous en montre plus ci-dessous ...


		////////////////////////////////////////////////////////////////
		// SoundOptionOnOff - CHANGE OPTIONS D'ORBITER SOUND 
		// En utilisant la fonction "SoundOptionOnOff" vous pouvez changer les 
		// options d'OrbiterSound. Ci-dessous nous desactivons l'ATC (Radio automatique) 
		// par defaut. (mais *notre* son Radio jouera quand meme, voir plus bas).
		SoundOptionOnOff(MyID,PLAYRADIOATC,FALSE);
		// On desactive aussi le compte a rebours par defaut quand on dcolle (ennuyeux) 
		SoundOptionOnOff(MyID,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);

		// Encore le clique droit infernal qui doit devenir un reflexe: cliquez droit sur
		// "PLAYCOUNTDOWNWHENTAKEOFF" plus haut et choisissez "atteindre dfinition"
		// vous aurez toutes les options possible de la fonction "SoundOptionOnOff"


		////////////////////////////////////////////////////////////////
		// CI_DESSOUS Demonstration des options possible pour les chargements des sons, ces 
		// options determinent la manire dont les sons seront utilis.
		////////////////////////////////////////////////////////////////

		////////////////////////////////////////////////////////////////
		// INTERNAL_ONLY - Joue uniquement dans le cockpit (ponctuel)
		// -----------
		// L'utilisation la plus basique d'Orbiter sound: jouer un son 
		// dans le cockpit en rponse  un vnement, touche clavier,
		// separation tage, click d'un bouton, systmes de bord etc etc.
		// En bref vous chargez un son et le jouez plus tard avec une fonction "play".
		// Dans cette demo la ligne ci-dessous va charger un wav "debout les gars"
		// et le jouer quand vous pressez la touche "B"
		// notez comme le son continue si vous "sortez" et "rentrez" dans le cockpit.
		RequestLoadVesselWave(MyID,MONWAVDEBOUTLESGARS,"deboutlesgars.wav",INTERNAL_ONLY);

		////////////////////////////////////////////////////////////////
		// INTERNAL_ONLY - Joue uniquement dans le cockpit (dynamique)
		// -------------
		// Ici on va charger un son radar qui va jouer seulement dans le cockpit, aprs dcollage
		// et seulement en dessous de 500m. Ce son sera "continuelle" (LOOP) et sa hauteur variera
		// avec l'altitude. (Notez l'option "INTERNAL_ONLY" clique droit pour autres options)
		// Ce son doit etre jou  chaque image voir fonction "JoueMesSonsChaqueImage()" en dessous.
		RequestLoadVesselWave(MyID,MONWAVRADAR,"myradar.wav",INTERNAL_ONLY);

		////////////////////////////////////////////////////////////////
		// RADIO_SOUND - Son ponctuelle, radio (indpendant du focus)
		// -----------
		// Ici par exemple nous allons jouer un son qui ne sera declench ponctuellement que 
		// quand on passe 500m d'altitude il s'agira en l'occurence d'un son "radio" 
		// qui joue aussi en vue exterieur. C'est un exemple de son jou dynamiquement.
		// comme on le jouera avec une fonction "playradioexclusive" il stoppera tout 
		// autres son radios (ATC) qui jouerais eventuellement en mme temps et jouera meme si
		// votre vessel n'a pas le focus (c'est pourquoi c'est un son "radio")
		RequestLoadVesselWave(MyID,MONWAV500METRES,"my500meter.wav",RADIO_SOUND);

		////////////////////////////////////////////////////////////////
		// EXTERNAL_ONLY_... - Vue exterieur seulement (dynamique)
		// -----------------
		// Ici un exemple d'un son externe qui doit etre attenu automatiquement en fonction
		// de la distance de la camera et de la pression externe. Il est important que vous jouiez ce son
		// en mode LOOP et a chaque image pour que les changements de volumes et de frequence soient
		// jou correctement. Le parametre "EXTERNAL_ONLY_FADED_CLOSE" veut dire que ce son sera
		// consider comme par exemple un son RCS, un son qui ne s'enttend pas  une grande distance 
		//(au contraire d'un son racteur par exemple)
		// Ce son doit etre jou  chaque image voir fonction "JoueMesSonsChaqueImage()" en dessous.
		RequestLoadVesselWave(MyID,MONWAVEXTERN_OVNI,"myUfoSound.wav",EXTERNAL_ONLY_FADED_CLOSE);

		////////////////////////////////////////////////////////////////
		// Sons 3D
		// -----------------
		// La 3D offre les mme possibilit que les sons prcdents, interne, externe mais en prime
		// il vous permet de positionner le son en 3D dans le cockpit ou  l'extrieur du vaisseaux.
		// (Clique droit sur la fonction pour voir toutes les possibilits, la demo de la SDK
		// contient plus d'exemples sur la 3D, voyez dans "Sound/OrbiterSound_SDK/VESSELSOUND_SDK"
		RequestLoad3DWaveMono(MyID,MONSON_3D_INTERNE,"myUfoSound.wav",INTERNAL_ONLY,&_V(0,0,-3));
}


////////////////////////////////////////////////////////////////////////////
// JoueMesSonsChaqueImage - notre fonction son appelle chaque image par clbkPostStep
// ----------------------
//
// Le plus souvent vos sons serons noys dans le reste du code, je les ai mis 
// dans cette fonction spar pour plus de lisibilit. Ce code est execut 
//  chaque image. Notez que le son jou par la touche clavier "B" ce trouve
// lui dans "clbkconsumeBufferedKey.cpp"
////////////////////////////////////////////////////////////////////////////
void MonAddon::JoueMesSonsChaqueImage(void)
{

		///////////////////////////////////////////////////////////////////
		// ORBITERSOUND EXEMPLE - JOUE LES SONS DYNAMIQUEMENT
		///////////////////////////////////////////////////////////////////

		// ----------------------------------------------------------
		// on joue le son "500 metre" qu'on a charg avant.
		// notez l'utilisation de nos variables donne simulation (data.)
		// et de flags pour detecter la passage des 500 metres et 
		// ne jouer le son qu'une seule fois a ce moment.
		// la fonction qui joue est "RadioExclusive.." car c'est un son radio.
		// ----------------------------------------------------------
		if(Data.dAltitude>500&&Data.dAltitude<550&&bAltitudeSoundPlayed==FALSE)
		{
			PlayVesselRadioExclusiveWave(MyID,MONWAV500METRES,255);	// 255=volume maximum 
			bAltitudeSoundPlayed=TRUE;
		}
		if(Data.dAltitude<500||Data.dAltitude>550)
			bAltitudeSoundPlayed=FALSE;


		// ------------------------------------------------------
		// Ici on joue le son radar qui change de frequence avec l'altitude
		// de 0  500 metres, notez qu'il joue "LOOP" (boucl) obligatoire
		// quand vous jouez un son dynamique qui change de volume et/ou de frequence.
		// notez aussi l'utilisation de flag pour le stopper en dessus de 500 metres
		// et au sol.
		// ------------------------------------------------------
		if(Data.dAltitude<500&&Data.dAltitude>2)
		{
			PlayVesselWave(MyID,MONWAVRADAR,LOOP,255,(int)(11025+((500-Data.dAltitude)*40)));		// play looped and a frequency that increase with altitude
			bRadarFlagForSound=TRUE;
		}
		else if(bRadarFlagForSound=TRUE)
		{
			// we stop the sound only once (it would not harm else but it will save a bit of processor time)
			StopVesselWave(MyID,MONWAVRADAR);
			bRadarFlagForSound=FALSE;
		}

		// ------------------------------------------------------
		// Ici on joue notre son "OVNI" 
		// ------------------------------------------------------
		// Comme mentionn un son qui joue en vue externe doit avoir son volume et frequence
		// chang par la distance de la camera et par la pression (pas de son dans l'espace)
		// OrbiterSound s'occupe de cela mais vous devez jouer le son a chaque image en
		// mode "LOOP" (boucl)
		// Nous avons rajout un petit effet: si le vessel est pos le son ce met
		// en "iddle" (frequence plus basse)
		if(Data.dAltitude<2)
			PlayVesselWave(MyID,MONWAVEXTERN_OVNI,LOOP,255,5000); // original wav is 11025 hz
		else
			PlayVesselWave(MyID,MONWAVEXTERN_OVNI,LOOP,255,11025);  
}

////////////////////////////////////////////////////////////////////////////
// ChargeEtJoue - Une fonction trs utile pour jouer des milliers de sons dans le cockpit
// -----------
//
// OrbiterSound n'a que 60 slots, l'enfer quand vous avez beaucoup de sons
// cockpit ponctuel comme des voix d'annonces, alarmes ou autres (Le Arrow Freighter en contient 153)
// Cette fonction utilitaire pour le "prix" de trois slots vous permet d'en jouer un nombre infini sans prise de tte.
// Donnez simplement le nom et il jouera immdiatement avec le volume voulu.
// Le fait d'avoir trois slots vous permet d'en jouer trois simultanement.
// Si vous lui donnez en plus une position il jouera en 3D dans le cockpit.
////////////////////////////////////////////////////////////////////////////
void MonAddon::ChargeEtJoue(char* NomWav,int Volume,VECTOR3 *v3Pos)
{
	iSlotChargeEtJoue++;  // utilisera le slot suivant
   // assure qu'on utilise bien nos trois slots et pas d'autres (pas besoin d'initialiser cette variable du coup
   // et c'est bien la seule de tous mes addons dans ce cas.)
   if(iSlotChargeEtJoue>SLOTVOIX3||iSlotChargeEtJoue<SLOTVOIX1)
           iSlotChargeEtJoue=SLOTVOIX1;
   if(v3Pos!=NULL)
		RequestLoad3DWaveMono(MyID,iSlotChargeEtJoue,NomWav,INTERNAL_ONLY,v3Pos);
   else
		RequestLoadVesselWave(MyID,iSlotChargeEtJoue,NomWav,INTERNAL_ONLY);

   PlayVesselWave(MyID,iSlotChargeEtJoue,NOLOOP,Volume);
}