#include "MaClasseAddon.h"

////////////////////////////////////////////////////////////////////////////
// SauveChargeScenario.cpp
// -----------------------
//
// Ce listing contient les deux callback Orbiter "clbkSaveState" et
// "clbkLoadStateEx" qui vous permettent de sauvez et recharger vos 
// variables dans/depuis un scenario.
//
// NE COMPTEZ PAS SUR CES FONCTIONS POUR INITIALISER VOS VARIABLES
// SI UN VAISEAU EST CREE PAR SCENARIO EDITOR PAR EXEMPLE ELLE NE SONT
// JAMAIS APPELLEES.
////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
// clbkSaveState - CallBack Orbiter
// -------------
//
// Fonction appelle par orbiter quand l'utilisateur quitte orbiter 
// ou appuie "CTL+S" cette fonction sauve dans un scenario les variables
// que vous dsirez. Par defaut il sauve aussi les donnes dont Orbiter
//  besoin pour repositionner votre vaisseau et le fuel.
//
////////////////////////////////////////////////////////////////////////////
void MonAddon::clbkSaveState(FILEHANDLE scn)
{

	// Sauve parametres par defaut, position, rotation, vitesse, fuel
	VESSEL2::clbkSaveState (scn);

	// Sauve notre compteur de temps. Regardez dans le scenario
	// une fois sauv pour voir apparaitre ce parametre.
	// pour sauver d'autre variable que int (entiere)
	// voir dans les exemples ou la doc "oapiWriteScenario".
	oapiWriteScenario_int (scn, "COMPTEUR", iTempDeSimulationTotal);

	// si on avais une autre valeur double par exemple:
	//oapiWriteScenario_float (scn, "MONCOCKPIT", dPositionCockpit);


}

////////////////////////////////////////////////////////////////////////////
// clbkLoadStateEx - CallBack Orbiter
// ---------------
//
// Fonction appelle par orbiter quand l'utilisateur  lanc un scenario 
// cette fonction retrouve les donnes par defaut comme position et fuel
// et retrouve aussi les variables que vous avez sauves dans la fonction
// "clbkSaveState" plus haut. A la fin de cette fonction une fois vos variables
// recharge vous devez operer tout traitement pour que votre vaisseau retrouve
// le mme tat qu'il avais lors de la dernire sauvegarde. 
//
// Exemple: vous avez sauv la variable de position des trains d'atterrissage
// une fois la variable recharge vous devez encore remettre l'animation
// des trains en fonction de cette variable, donc "SetAnimation(MaVariableSauvee)"
////////////////////////////////////////////////////////////////////////////
void MonAddon::clbkLoadStateEx(FILEHANDLE scn, void *vs)
{
		char *line;

		// Pour chaque ligne du scenario
		while (oapiReadScenario_nextline (scn, line)) 
		{
			// regarde si cette ligne contient "COMPTEUR" que nous avions sauv
			if (!_strnicmp (line, "COMPTEUR", 8)) 
			{
				// si oui lis la valeur (%i= entiere ou int)
				sscanf (line+8, "%i", &iTempDeSimulationTotal);
			} 
			// exemple si on avait un autre parametre notez le "else if"
			// cette ligne ne fera rien c'est juste pour vous montrer on cas
			// ou on a plusieurs variable  charger.
			else if (!_strnicmp (line, "MONCOCKPIT",10)) 
			{
				// juste pour l'exemple ici si on avait une valeur float ou "double".
				//sscanf (line+10, "%lf", &dPositionCockpit);
			} 
			// si ne correspond a aucune de nos lignes passe la ligne
			// a Orbiter.
			else 
			{
				// Orbiter charge les parametres par defaut (position, fuel, moteur etc etc)
				ParseScenarioLineEx (line, vs);
			}
		}


		//////////////////////////////////////////////////////////////////
		// IMPORTANT: 
		// Ici vos variables on enfin la mme valeur que lorsque le scenario  
		// a t sauv, c'est ici dessous que vous devez utiliser ces valeurs
		// pour remettre votre vaisseaux dans le mme tat que lors de la sauvegarde.
		// Ne vous occupez pas des moteurs, fuel, position, rotation, vitesse
		// Orbiter ce debrouille, par contre tout le reste dpend de vous.
		// (animations, systeme de bord etc etc)
		//////////////////////////////////////////////////////////////////


}