#include "MaClasseAddon.h"

////////////////////////////////////////////////////////////////////////////
// clbkPostStep - CallBack Orbiter
// ------------
//
// Fonction appelle par orbiter  chaque image. Tout ce qui est
// dynamique (execut  chaque image) va ici.
//
////////////////////////////////////////////////////////////////////////////
void MonAddon::clbkPostStep(double simt, double simdt, double mjd)
{
	//////////////////////////////////////////////////////////////
	// COLLECTE DES DONNEES SIMULATION POUR LES AVOIR A DISPO 
	// DANS LE RESTE DU CODE. VOIR HEADER "MesDonneeSimulation.h" 
	// POUR EXPLICATION COMPLETE. 
	// Voir structure "Data" pour liste complete des donnes disponible.
	Data.dAltitude		=GetAltitude();		// collecte votre altitude (m)
	Data.dVitesse		=GetAirspeed();		// collecte votre vitesse (m/s)
	Data.dAtmPressure	=GetAtmPressure();	// pression atmosphere en pascal (101000 Pa =terre)
	Data.dDynPressure	=GetDynPressure();	// Pression dynamique
	Data.dVitesseKmh	=Data.dVitesse*3.6f;// Vitesse en Km/h
	Data.dMachNumber	=GetMachNumber();	// nombre de mach
	GetHorizonAirspeedVector (Data.vHorizonAirspeedVector);  // vitesse verticale en m/s
	Data.dVitesseVerticale=Data.vHorizonAirspeedVector.y;
	Data.dAOA			=GetAOA();			// AOA En radian (Data.dAOA*DEG pour degr)
	Data.dPitch			=GetPitch();		// pitch En Radian (Data.dPitch*DEG pour degr)
	Data.dBank			=GetBank();			//Bank En Radian (Data.dBank*DEG pour degr)
	Data.iTimeWarp=(int)oapiGetTimeAcceleration();// Acceleration du temps (1= normal sinon 10,1000,10000 etc etc)
	Data.dMass=GetMass();
	// collecte nom planete SOI et si air respirable (vous etes sur terre)
	OBJHANDLE ObjHandleSurfRef=GetSurfaceRef();	
	Data.bAirRespirable=FALSE;
	if(ObjHandleSurfRef!=NULL)
	{	
		oapiGetObjectName (ObjHandleSurfRef,Data.cNomPlanete,255);
		if(strcmp(Data.cNomPlanete,"Earth")==0)
		{
			if(Data.dAltitude<10000)
				Data.bAirRespirable=TRUE;		// si l'air est respirable (sur terre et altitude<10000)
		}
	}
	// Collecte acceleration "G" Resultat dans Data.dGVert=composante verticale (tete/pieds pour pilot assis normalement) 
	// et Data.dGTotal=tout vecteur
	VECTOR3 vWeight,vForce,vResult;
	GetWeightVector(vWeight);
	GetForceVector(vForce);
	vResult=(vForce-vWeight)/Data.dMass;
	Data.dGVert=0.90*Data.dGVert+0.10*vResult.y/9.80665;
	Data.dGTotal=0.90*Data.dGTotal+0.10*(length(vResult)/9.80665);
	// Fin collecte des donnes elles sont dispo pour votre code.
	///////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////
	// TRUC A PROPOS DES DONNES DATA:
	// Si vous tapez "Data." dans le source une liste apparaitra avec toutes 
	// les variables dispos prete  selectionner. Pour que ca marche le code 
	//  du etre compil avec succs. (inttelisense)
	////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////
	// TRUC A PROPOS D'OPTIMISATION:
	// N'oubliez jamais que cette fonction est execute  chaque image
	// donc 60 fois par secondes par exemple sur un ordi moyen. Si vous
	// ne faites pas gaffe a ce que vous executez ici vous allez transformer
	// orbiter en "soire dispositive" avec un taux d'image par seconde affreux.
	// 1-ne chargez pas de truc depuis le disque ici
	// 2-Eliminez le plus possible de code non indispensable  chaque image avec 
	// des variables d'tat. Un exemple: Vous avez 50 ligne de codes qui 
	// s'occupent de la sant de votre equipage, si la pression cabine n'a pas change
	// il n'y a aucune raison que votre equipage tombe malade, donc testez la
	// pressions et n'executez le code que si la pression  change.
	// Pour ce faire on va utiliser une variable qui va enregistrer la pression
	// la derniere fois que vos 50 lignes on t execut et la comparer  chaque image
	// avec la pression actuelle, si elle ne sont pas egale, la pression a change
	// et votre code est execut, rsultat: un test seulement dans la plupart des cas
	// au lieu de 50 lignes. Exemple:
	// if(PressionActuelle!=AnciennePression)   //"!=" ca veut dire "non gale
	// {
	//   ....ici les 50 lignes
	//   AnciennePression=PressionActuelle;     //AnciennePression est egale  l'actuelle.
	// }
	//
	// Le C++ est *incroyablement* rapide, mais il y a des limites, une grosse erreur
	// de programation peut l'amener facilement  executer des milliers de lignes
	// pour rien, faite gaffe ici, ca peut "tuer" votre addon !!!!
	//
	// Si vous voulez tester votre addon avec un framerate trs bas (peut tre utile)
	// imbriquez plusieurs boucle for next qui ce repettent quelques millions de fois
	// et oubliez pas de l'enlever ;))))
	////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////
	// EXEMPLE DE VARIABLE
	// Regardez dans le header "MaClasseAddon.h" pour une explication complete.
	if(iDetecteChangementSeconde!=(int)simt)
	{
		// le principe: simt donne par la fonction contient le temp actuel de simulation en seconde 
		// je le stock dans dDetecteChangementSeconde et je la compare a chaque image avec le temp
		// actuel, si pas egal une seconde c'est ecoule j'incrmente de 1 dTempDeSimulationTotal.
		// comme dTempDeSimulationTotal est sauve/recharge du scenario elle affichera le temps
		// total de vol *avec ce scenario* (on pourrait faire un temp total de vol avec votre addon 
		// en sauvant dans un fichier externe mais on va pas exagerer dans ce template.)
		iTempDeSimulationTotal++;
		iDetecteChangementSeconde=(int)simt;
	}

	// on affiche notre compteur
	sprintf(oapiDebugString(),"Compteur temp scenario total: %i - Pressez B pour son interne, C pour reset compteur, 1, 2 et 3 pour son 'ChargeEtJoue()' interne",iTempDeSimulationTotal);

	////////////////////////////////////////////////////////////////////////
	// DEMO ORBITERSOUND
	// Regardez dans le "orbiterSound.cpp" pour une explication complete.
	JoueMesSonsChaqueImage();

}