#include "MaClasseAddon.h"

////////////////////////////////////////////////////////////////////////////
// clbkSetClassCaps - CallBack Orbiter
// ----------------------
//
// Fonction appelle par orbiter quand le vaisseau est cre dans Orbiter
// que ce soit par scenario editor ou au lancement d'une scenario.
// La definition des caracteristiques de votre vaisseau comme taille, poids, moteur
// rcs inertie, modele de vol, meshe utilis et bien d'autre choses ce fait ici.
//
// L'initialisation par defaut de toutes vos variables ainsi que toute 
// autre initialisations pour votre vaisseau doit ce faire ici aussi.
//
// SI VOUS N'INITIALISEZ PAS VOS VARIABLES DE CLASSE ICI ELLES AURONS UN ETAT INDEFINI
// CA PEUT ETRE N'IMPORTE QUEL CHIFFRE GENRE "4654345.435" CA VA PAS MARCHER 
// SUPER VOTRE CODE AVEC DES VARIABLES COMME CA. (ARRACHAGE DE CHEVEUX)
////////////////////////////////////////////////////////////////////////////
void MonAddon::clbkSetClassCaps (FILEHANDLE cfg)
{

	//////////////////////////////////////////////////////////////
	// INITIALISATION PAR DEFAUT DE VOS VARIABLES DE CLASSE ICI !!!
	iTempDeSimulationTotal=0;		// notre variable exemple, init par defaut elle sera recharge dans "clbkLoadStateEx"
	iDetecteChangementSeconde=0;	// sert aussi  la variable "dTempDeSimulationTotal"
	bAltitudeSoundPlayed=FALSE;		// utilis par la dmo d'OrbiterSound
	bRadarFlagForSound=FALSE;		// utilis par la demo d'OrbiterSound
	memset(&Data,0,sizeof(Data));	// remet  zro en une fois toutes les variables de la structure "Data"
	// Fin initialisation variable de classe
	//////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////
	// MESH UTILISE PAR VOTRE ADDON 
	AddMesh ("ShuttlePB");
	// TRUC: on peut loader d'autres meshes et les faires apparaitre/disparaitre
	// au cours de la simulation. Utile pour par exemple afficher le mesh des 
	// astronautes suivant si ils sont en cabine ou pas. Par exemple la ligne ci-dessous insere
	// un mesh "MesAstronautes.msh" dans le slot "2" et le fait apparaitre
	// SetMeshVisibilityMode(InsertMesh(oapiLoadMeshGlobal ("MonAddon\\MesAstronautes"),2),MESHVIS_EXTERNAL);
	// Plus tard dans votre code ceci le fait disparaitre: SetMeshVisibilityMode(2,MESHVIS_NEVER);
	// et ceci le fait apparaitre : SetMeshVisibilityMode(2,MESHVIS_EXTERNAL);
	// (Notez le "2" est l'index du slot ou le mesh a t charg)
	//////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////
	// DEFINITIONS PHYSIQUE DE VOTRE ADDON 
	// taille, poid a vide, modele de vol, placement camera, inertie etc etc. c'est la.
	// La elle sont pour un shuttlePB, regardez les autres exemples "clbkSetClassCaps"
	// deltaglider et Shuttle pour voir comment les autres vaisseaux
	// sont dfini. Regardez aussi dans la doc  propos de chaque fonction
	// ci dessous.
	SetSize (3.5);
	SetEmptyMass (500.0);
	SetCW (0.3, 0.3, 0.6, 0.9);
	SetWingAspect (0.7);
	SetWingEffectiveness (2.5);
	SetCrossSections (_V(10.5,15.0,5.8));
	SetRotDrag (_V(0.6,0.6,0.35));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (1e-4);
		SetBankMomentScale (1e-4);
	}
	SetPMI (_V(2.28,2.31,0.79));
	SetTrimScale (0.05);
	SetCameraOffset (_V(0,0.8,0));
	SetLiftCoeffFunc (LiftCoeff);
	SetDockParams (_V(0,1.3,-1), _V(0,1,0), _V(0,0,-1));
	SetTouchdownPoints (_V(0,-1.5,2), _V(-1,-1.5,-1.5), _V(1,-1.5,-1.5));
	// Fin definition physique
	///////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////
	// DEFINITIONS DIVERS FUMEE POUR MOTEUR
	// voir la doc et les exemples pour ca
	PARTICLESTREAMSPEC contrail_main = {
		0, 5.0, 16, 200, 0.15, 1.0, 5, 3.0, PARTICLESTREAMSPEC::DIFFUSE,
		PARTICLESTREAMSPEC::LVL_PSQRT, 0, 2,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-4, 1
	};
	PARTICLESTREAMSPEC contrail_hover = {
		0, 5.0, 8, 200, 0.15, 1.0, 5, 3.0, PARTICLESTREAMSPEC::DIFFUSE,
		PARTICLESTREAMSPEC::LVL_PSQRT, 0, 2,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-4, 1
	};
	PARTICLESTREAMSPEC exhaust_main = {
		0, 2.0, 20, 200, 0.05, 0.1, 8, 1.0, PARTICLESTREAMSPEC::EMISSIVE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-5, 0.1
	};
	PARTICLESTREAMSPEC exhaust_hover = {
		0, 2.0, 10, 200, 0.05, 0.05, 8, 1.0, PARTICLESTREAMSPEC::EMISSIVE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-5, 0.1
	};

	//////////////////////////////////////////////////////////////
	// DEFINITIONS RESERVOIR FUEL DE VOTRE ADDON 
	// Vous pouvez en definir autant que vous voulez, notez que le
	// handle "hpr" est utilis plus bas par les moteurs: ils seront
	// li et utiliserons ce reservoir. 
	PROPELLANT_HANDLE hpr = CreatePropellantResource (PB_FUELMASS);

	//////////////////////////////////////////////////////////////
	// DEFINITIONS MOTEURS ET RCS DE L'ADDON
	// voir la doc et les exemples pour ca (demmerdez vous un peu quoi ;) 
	THRUSTER_HANDLE th_main, th_hover, th_rcs[14], th_group[4];
	th_main = CreateThruster (_V(0,0,-4.35), _V(0,0,1), PB_MAXMAINTH, hpr, PB_ISP);
	CreateThrusterGroup (&th_main, 1, THGROUP_MAIN);
	AddExhaust (th_main, 8, 1, _V(0,0.3,-4.35), _V(0,0,-1));

	th_hover = CreateThruster (_V(0,-1.5,0), _V(0,1,0), PB_MAXHOVERTH, hpr, PB_ISP);
	CreateThrusterGroup (&th_hover, 1, THGROUP_HOVER);
	AddExhaust (th_hover, 8, 1, _V(0,-1.5,1), _V(0,-1,0));
	AddExhaust (th_hover, 8, 1, _V(0,-1.5,-1), _V(0,-1,0));

	AddExhaustStream (th_hover, _V(0,-3, 1), &contrail_hover);
	AddExhaustStream (th_hover, _V(0,-3,-1), &contrail_hover);
	AddExhaustStream (th_main, _V(0,0.3,-10), &contrail_main);
	AddExhaustStream (th_hover, _V(0,-2, 1), &exhaust_hover);
	AddExhaustStream (th_hover, _V(0,-2,-1), &exhaust_hover);
	AddExhaustStream (th_main, _V(0,0.3,-5), &exhaust_main);

	th_rcs[ 0] = CreateThruster (_V( 1,0, 3), _V(0, 1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 1] = CreateThruster (_V( 1,0, 3), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 2] = CreateThruster (_V(-1,0, 3), _V(0, 1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 3] = CreateThruster (_V(-1,0, 3), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 4] = CreateThruster (_V( 1,0,-3), _V(0, 1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 5] = CreateThruster (_V( 1,0,-3), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 6] = CreateThruster (_V(-1,0,-3), _V(0, 1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 7] = CreateThruster (_V(-1,0,-3), _V(0,-1,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 8] = CreateThruster (_V( 1,0, 3), _V(-1,0,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[ 9] = CreateThruster (_V(-1,0, 3), _V( 1,0,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[10] = CreateThruster (_V( 1,0,-3), _V(-1,0,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[11] = CreateThruster (_V(-1,0,-3), _V( 1,0,0), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[12] = CreateThruster (_V( 0,0,-3), _V(0,0, 1), PB_MAXRCSTH, hpr, PB_ISP);
	th_rcs[13] = CreateThruster (_V( 0,0, 3), _V(0,0,-1), PB_MAXRCSTH, hpr, PB_ISP);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[2];
	th_group[2] = th_rcs[5];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHUP);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[3];
	th_group[2] = th_rcs[4];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHDOWN);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[4];
	th_group[2] = th_rcs[3];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKLEFT);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[2];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKRIGHT);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[4];
	th_group[2] = th_rcs[2];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_UP);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[3];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_DOWN);

	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWLEFT);

	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWRIGHT);

	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_LEFT);

	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_RIGHT);

	CreateThrusterGroup (th_rcs+12, 1, THGROUP_ATT_FORWARD);
	CreateThrusterGroup (th_rcs+13, 1, THGROUP_ATT_BACK);
}